/*
 * Copyright (C) 2017 Muhammad Tayyab Akram
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.mta.tehreer.internal;

public class JniBridge {

    private static boolean loaded = false;

    public static void loadLibrary() {
        if (!loaded) {
            synchronized (JniBridge.class) {
                if (!loaded) {
                    System.loadLibrary("tehreerjni");
                    loaded = true;
                }
            }
        }
    }

    private JniBridge() {
    }
}
